Index: sansview/perspectives/fitting/basepage.py
===================================================================
--- sansview/perspectives/fitting/basepage.py	(revision 60132ef18e274730daf212156c736dd44e98affe)
+++ sansview/perspectives/fitting/basepage.py	(revision 298b76252a7723b414f74329d945b01c2b694ef9)
@@ -1029,10 +1029,10 @@
                 param_max= None
                 if item[5]!= None:
-                    if format_number(item[5].GetValue())!="NaN":
+                    if item[5].GetValue().lstrip().rstrip()!="":
                         param_min = float(item[5].GetValue())
                     
                 ## check maximum value
                 if item[6]!= None:
-                    if format_number(item[6].GetValue())!="NaN":
+                    if item[6].GetValue().lstrip().rstrip()!="":
                         param_max = float(item[6].GetValue())
                         
Index: sansview/perspectives/fitting/fitpage.py
===================================================================
--- sansview/perspectives/fitting/fitpage.py	(revision 875f1a2367e7416d2e58dd76c1d23dd999c760e1)
+++ sansview/perspectives/fitting/fitpage.py	(revision 298b76252a7723b414f74329d945b01c2b694ef9)
@@ -461,5 +461,23 @@
         wx.PostEvent(self.event_owner, evt)   
         
-
+   
+    def _onparamRangeEnter(self, event):
+        """
+            Check validity of value enter in the parameters range field
+        """
+        tcrtl= event.GetEventObject()
+        if tcrtl.GetValue().lstrip().rstrip()!="":
+            try:
+                value = float(tcrtl.GetValue())
+                tcrtl.SetBackgroundColour(wx.WHITE)
+                tcrtl.Refresh()
+            except:
+                tcrtl.SetBackgroundColour("pink")
+                tcrtl.Refresh()
+        else:
+           tcrtl.SetBackgroundColour(wx.WHITE)
+           tcrtl.Refresh()  
+        self._onparamEnter_helper()    
+        
     def _onparamEnter(self,event):
         """ 
@@ -858,8 +876,11 @@
                 ix += 1
                 ctl3 = wx.TextCtrl(self, -1, size=(_BOX_WIDTH/2,20), style=wx.TE_PROCESS_ENTER)
-                ctl3.SetValue(str(param_min))
+                if param_min ==None:
+                    ctl3.SetValue("")
+                else:
+                    ctl3.SetValue(str(param_min))
                 ctl3.Bind(wx.EVT_SET_FOCUS, self.onSetFocus)
-                ctl3.Bind(wx.EVT_KILL_FOCUS, self._onparamEnter)
-                ctl3.Bind(wx.EVT_TEXT_ENTER,self._onparamEnter)
+                ctl3.Bind(wx.EVT_KILL_FOCUS, self._onparamRangeEnter)
+                ctl3.Bind(wx.EVT_TEXT_ENTER,self._onparamRangeEnter)
                 sizer.Add(ctl3, (iy,ix),(1,1), wx.EXPAND|wx.ADJUST_MINSIZE, 0)
                 ctl3.Hide()
@@ -868,8 +889,11 @@
                 ctl4 = wx.TextCtrl(self, -1, size=(_BOX_WIDTH/2,20), style=wx.TE_PROCESS_ENTER)
                 ctl4.Bind(wx.EVT_SET_FOCUS, self.onSetFocus)
-                ctl4.Bind(wx.EVT_KILL_FOCUS, self._onparamEnter)
-                ctl4.Bind(wx.EVT_TEXT_ENTER,self._onparamEnter)
+                ctl4.Bind(wx.EVT_KILL_FOCUS, self._onparamRangeEnter)
+                ctl4.Bind(wx.EVT_TEXT_ENTER,self._onparamRangeEnter)
                 sizer.Add(ctl4, (iy,ix),(1,1), wx.EXPAND|wx.ADJUST_MINSIZE, 0)
-                ctl4.SetValue(str(param_max))
+                if param_max==None:
+                    ctl4.SetValue("")
+                else:
+                    ctl4.SetValue(str(param_max))
                 ctl4.Hide()
                 
@@ -939,8 +963,11 @@
                 ix += 1
                 ctl3 = wx.TextCtrl(self, -1, size=(_BOX_WIDTH/2,20), style=wx.TE_PROCESS_ENTER)
-                ctl3.SetValue(str(param_min))
+                if param_min ==None:
+                    ctl3.SetValue("")
+                else:
+                    ctl3.SetValue(str(param_min))
                 ctl3.Bind(wx.EVT_SET_FOCUS, self.onSetFocus)
-                ctl3.Bind(wx.EVT_KILL_FOCUS, self._onparamEnter)
-                ctl3.Bind(wx.EVT_TEXT_ENTER,self._onparamEnter)
+                ctl3.Bind(wx.EVT_KILL_FOCUS, self._onparamRangeEnter)
+                ctl3.Bind(wx.EVT_TEXT_ENTER,self._onparamRangeEnter)
                 sizer.Add(ctl3, (iy,ix),(1,1), wx.EXPAND|wx.ADJUST_MINSIZE, 0)
                 ctl3.Hide()
@@ -949,10 +976,9 @@
                 else:
                     ctl3.Disable()
-        
                 ix += 1
                 ctl4 = wx.TextCtrl(self, -1, size=(_BOX_WIDTH/2,20), style=wx.TE_PROCESS_ENTER)
                 ctl4.Bind(wx.EVT_SET_FOCUS, self.onSetFocus)
-                ctl4.Bind(wx.EVT_KILL_FOCUS, self._onparamEnter)
-                ctl4.Bind(wx.EVT_TEXT_ENTER,self._onparamEnter)
+                ctl4.Bind(wx.EVT_KILL_FOCUS, self._onparamRangeEnter)
+                ctl4.Bind(wx.EVT_TEXT_ENTER,self._onparamRangeEnter)
                 sizer.Add(ctl4, (iy,ix),(1,1), wx.EXPAND|wx.ADJUST_MINSIZE, 0)
                 ctl4.SetValue(str(param_max))