Index: sansview/perspectives/fitting/basepage.py
===================================================================
--- sansview/perspectives/fitting/basepage.py	(revision f867cd99b41e1e3c36ce344d9791e93e37fe6bde)
+++ sansview/perspectives/fitting/basepage.py	(revision 340c2b394c77bda9152c0196371422d89d53b479)
@@ -1,4 +1,5 @@
 
-import sys, os
+import sys
+import os
 import wx
 import numpy
@@ -7,4 +8,5 @@
 import math
 import string
+from wx.lib.scrolledpanel import ScrolledPanel
 from sans.guiframe.utils import format_number,check_float
 from sans.guicomm.events import StatusEvent
@@ -29,5 +31,5 @@
     ON_MAC = True
     
-class BasicPage(wx.ScrolledWindow):
+class BasicPage(wx.ScrolledPanel, PanelBase):
     """
     This class provide general structure of  fitpanel page
@@ -43,4 +45,6 @@
         wx.ScrolledWindow.__init__(self, parent, 
                                    style=wx.FULL_REPAINT_ON_RESIZE)
+        PanelBase.__init__(self)
+        self.SetupScrolling()
         #Set window's font size 
         self.SetWindowVariant(variant=FONT_VARIANT)
@@ -340,15 +344,6 @@
         self.vbox.Fit(self) 
         self.SetSizer(self.vbox)
-       
-        self.set_scroll()
         self.Centre()
-    
-    def set_scroll(self):
-        """
-        """
-        self.SetScrollbars(20,20,25,65)
-        self.Layout()   
-        self.SetAutoLayout(True)
-         
+ 
     def set_owner(self,owner):
         """ 
@@ -476,5 +471,5 @@
         self.sizer4.Layout()
         self.Layout()
-        self.SetScrollbars(20,20,25,65)
+     
         self.Refresh()
         ## saving the state of enable dispersity button
@@ -1522,5 +1517,5 @@
                 items = self.structurebox.GetItems()
                 self.sizer1.Layout()
-                self.SetScrollbars(20, 20, 25 ,65)
+                
                 for i in range(len(items)):
                     if items[i]== str(name):
@@ -1737,7 +1732,5 @@
         sizer.Add(boxsizer1,0, wx.EXPAND | wx.ALL, 10)
         sizer.Layout()
-        self.SetScrollbars(20,20,25,65)
-        
-        
+       
     def _on_show_sld(self, event=None):
         """
@@ -1835,6 +1828,5 @@
         self.Layout()
         self.Refresh()
-        self.SetScrollbars(20,20,25,65)
-            
+  
     def _populate_box(self, combobox, list):
         """
@@ -2236,7 +2228,5 @@
         self.sizer4_4.Layout()
         self.sizer4.Layout()
-        self.SetScrollbars(20,20,25,65)
-      
-            
+    
     def _reset_dispersity(self):
         """
@@ -2307,6 +2297,5 @@
         self.sizer4_4.Layout()
         self.sizer4.Layout()
-        self.SetScrollbars(20,20,25,65)
-        
+    
     def _set_sizer_arraydispersion(self):
         """
@@ -2489,6 +2478,5 @@
         self.sizer6.Add(boxsizer1,0, wx.EXPAND | wx.ALL, 10)
         self.sizer6.Layout()
-        self.SetScrollbars(20,20,25,65)
-        
+    
     def _lay_out(self):
         """
Index: sansview/perspectives/fitting/fitpanel.py
===================================================================
--- sansview/perspectives/fitting/fitpanel.py	(revision 645f9b608b1e7601b317cf47860710c53af92251)
+++ sansview/perspectives/fitting/fitpanel.py	(revision 340c2b394c77bda9152c0196371422d89d53b479)
@@ -5,4 +5,5 @@
 import wx.aui
 
+from sans.guiframe.panel_base import PanelBase
 import basepage
 
@@ -144,5 +145,5 @@
         self.type = "Data"
         
-class FitPanel(wx.aui.AuiNotebook):    
+class FitPanel(wx.aui.AuiNotebook, PanelBase):    
 
     """
@@ -166,8 +167,9 @@
                     wx.aui.AUI_NB_DEFAULT_STYLE|
                     wx.CLIP_CHILDREN)
-    
-        self.manager=None
-        self.parent=parent
-        self.event_owner=None
+        PanelBase.__init__(self)
+    
+        self.manager = None
+        self.parent = parent
+        self.event_owner = None
         
         pageClosedEvent = wx.aui.EVT_AUINOTEBOOK_PAGE_CLOSE
@@ -191,5 +193,5 @@
         
         # increment number for model name
-        self.count=0
+        self.count = 0
         #updating the panel
         self.Update()